#ifndef DEF_H
#define DEF_H

#define XSPACE		5
#define YSPACE		5
#define YFACETEXT	3
#define YTEXT		12
#define MAXXFACE	10
#define MAXFLOAT 	30000

/* Commands */
#define CMD_TRAINING							0
#define CMD_RECONSTRUCTION					1
#define CMD_RECOGNIZE						2
#define CMD_MEET								3
#define CMD_LOAD_EIGEN						4
#define CMD_SAVE_EIGEN_DB					5
#define CMD_SAVE_EIGEN						6
#define CMD_SAVE_REPORT						7
#define CMD_SAVE_CMP_MEET					8
#define CMD_SAVE_CMP_RECONSTRUCTION		9
#define CMD_SAVE_CMP_RECOGNITION			10
#define CMD_LOAD_MEET						11
#define CMD_CATEGORIZE						12
#define CMD_MAX								13

typedef struct _GEOMPARAMS
	{
	int xNum;						/*Number of columns of faces */
	int yNum;						/*Number of lines of faces -1*/
	int lastNum;					/*Number of columns of faces on the last line*/
	}GEOMPARAMS;

typedef struct _CORNER
	{
	int x, y;
	}CORNER;

#endif /* DEF_H */
