#ifndef STR_H
#define STR_H

/* Useful strings */
extern char chr_RT1;
extern char chr_RT2;
extern char chr_BTAG;
extern char str_BTAG[];
extern char chr_PROJ_COMMENT;
extern char str_RET[];
extern char str_TABRT[];
extern char str_END[];
extern char str_DIR[];
extern char chr_DIR;
extern char str_EXT_TXT[];
extern char str_SAVE_NUM[];

/* face file opening strings */
extern char str_ERR_FILE_OPEN[];
extern char str_ERR_FILE_READPROB[];
extern char str_ERR_FILE_WRITE[];
extern char str_ERR_FILE_EXT[];
extern char str_ERR_FILE_LOCATE[];
extern char str_ERR_FILE_CLOSE[];
extern char str_ERR_ASCIIBIN[];
extern char str_ERR_FILE_UNEXPECTEDEOF[];
extern char str_ERR_NOT255[];
extern char str_LOADED[];
extern char str_LOADING[];
extern char str_SAVING[];
extern char str_SAVED[];

/* face database */
extern char str_ERR_DIMENSION[];

/* project file strings */
extern char str_TRAINING[];
extern char str_RECONSTRUCTION[];
extern char str_RECOGNIZE[];
extern char str_MEET[];
extern char str_SAVE_EIGEN[];
extern char str_SAVE_EIGEN_DB[];
extern char str_SAVE_REPORT[];
extern char str_SAVE_CMP_MEET[];
extern char str_SAVE_CMP_RECONSTRUCTION[];
extern char str_SAVE_CMP_RECOGNIZE[];
extern char str_LOAD_EIGEN[];
extern char str_PROJECT_TRAINING[];
extern char str_PROJECT_TRAINING_DONE[];
extern char str_PROJECT_RECONSTRUCTION[];
extern char str_PROJECT_RECONSTRUCTION_DONE[];
extern char str_PROJECT_RECOGNIZE[];
extern char str_PROJECT_RECOGNIZE_DONE[];
extern char str_PROJECT_MEET[];
extern char str_PROJECT_MEET_DONE[];
extern char str_PROJECT_LOAD_EIGEN[];
extern char str_PROJECT_LOAD_EIGEN_DONE[];
extern char str_PROJECT_LOAD_MEET[];
extern char str_PROJECT_LOAD_MEET_DONE[];
extern char str_PROJECT_SAVE_EIGEN[];
extern char str_PROJECT_SAVE_EIGEN_DONE[];
extern char str_PROJECT_SAVE_EIGEN_DB[];
extern char str_PROJECT_SAVE_EIGEN_DB_DONE[];
extern char str_PROJECT_SAVE_REPORT[];
extern char str_PROJECT_SAVE_REPORT_DONE[];
extern char str_PROJECT_SAVE_CMP_MEET[];
extern char str_PROJECT_SAVE_CMP_MEET_DONE[];
extern char str_PROJECT_SAVE_CMP_RECONSTRUCTION[];
extern char str_PROJECT_SAVE_CMP_RECONSTRUCTION_DONE[];
extern char str_PROJECT_SAVE_CMP_RECOGNITION[];
extern char str_PROJECT_SAVE_CMP_RECOGNITION_DONE[];
extern char str_EVAL_FILENAME[];
extern char str_ALREADY_LOAD_EIGEN[];
extern char str_ALREADY_TRAINING[];
extern char str_ALREADY_MEET[];
extern char str_NOTYET_EIGEN[];
extern char str_NOTYET_MEET[];
extern char str_NOTYET_RECONSTRUCTION[];
extern char str_NOTYET_RECOGNITION[];
extern char str_ERR_WRONGARG[];
extern char str_ERR_TRAINING[];
extern char str_ERR_FILE_READ[];
extern char str_ERR_TRAINING_ENDTAG[];
extern char str_ERR_RECONSTRUCTION_ENDTAG[];
extern char str_ERR_RECOGNIZE_ENDTAG[];
extern char str_ERR_MEET_ENDTAG[];
extern char str_ERR_LOAD_EIGEN_ENDTAG[];
extern char str_PROJECT_LOADING[];
extern char str_ERR_MISMATCH[];
extern char str_ERR_AAMNOTCREATE[];

/* Memory */
extern char str_ERR_MEM_ALLOCATE[];
extern char str_ERR_MEM_REALLOCATE[];
extern char str_ERR_MEM_GETPTR[];

/* Matrix */
extern char str_TOOITER[];
extern char str_ERR_MAT_COPY[];
extern char str_ERR_MAT_LOAD_ROW[];
extern char str_ERR_MAT_LOAD_COL[];
extern char str_ERR_MAT_LOAD_HDR[];

/* Auto-Associative Memory */
extern char str_AAM_BUILD_START[];
extern char str_AAM_BUILD_NORMALIZED[];
extern char str_AAM_BUILD_INNER[];
extern char str_AAM_BUILD_EIGEN1[];
extern char str_AAM_BUILD_SORT[];
extern char str_AAM_BUILD_DONE[];
extern char str_AAM_RECONSTRUCTION_START[];
extern char str_AAM_RECONS_NORMALIZED[];
extern char str_AAM_RECONSTRUCTION_DONE[];
extern char str_AAM_RECOGNIZE_START[];
extern char str_AAM_RECOG_NORMALIZED[];
extern char str_AAM_MEET_NORMALIZED[];
extern char str_AAM_RECOG_CLASS[];
extern char str_AAM_RECOG_CLASS_DONE[];
extern char str_AAM_RECOGNIZE_DONE[];
extern char str_AAM_RECOGNIZE_PERCENT[];
extern char str_RECOGNITION_RESULT_Y[];
extern char str_RECOGNITION_RESULT_N[];
extern char str_RECOGNITION_I[];
extern char str_AAM_F2CMP[];
extern char str_AAM_CMP2F[];
extern char str_AAM_COS_DONE[];

/* Messages */
extern char str_MSG_MORE_H[];
extern char str_MSG_MORE_M[];
extern char str_MSG_MORE_S[];
extern char str_MSG_MORE_MS[];

#endif /* STR_H */
