#ifndef MATRXSYM_H
#define MATRXSYM_H

#include "CVect.h"
#include "CMat.h"

class CMatrixSym : public CMatrix
	{
	private:
	public:
		CMatrixSym();
		CMatrixSym(long l);
		~CMatrixSym();
		virtual long GetCol();
		virtual long GetLi();
		
		int Eigen(CMatrix *Q, CVect *ev);	/* Puts in Q the eigenvectors and in ev the eigenvalues of the matrix*/
		int Put(CMatrix *Q);				/* Puts all the elements of this matrix into the pointer to a CMatrix object*/
	private:
		virtual void Allocate();			/*Allocate (or reallocate) the memory*/
											/*needed by pData; Call the CMemory's Allocate fct*/
	public:
	virtual valtype GetAt(long l, long c);
	virtual void SetAt(long l, long c, valtype value);
	};

#endif /*MATRXSYM_H*/
