#ifndef CDRAWREC_H
#define CDRAWREC_H

#include "CFaceDB.h"
#include "def.h"
#include "CDiag.h"

class CDrawReconstruction : public CFrameWnd
	{
	private:
		CFaceDB *pFaceDB1;								/*Face DataBase1 data*/
		CFaceDB *pFaceDB2;
		GEOMPARAMS gp;
		
		int nVPos;
		int nMaxVPos;
		int nHPos;
		int nMaxHPos;
			
		HFONT 		hfont, hfontOld;		/*Character font*/
		int 			MapModePrevious;

	public:
		CDrawReconstruction();
		
		void				SetFaceDB(CFaceDB *pFaceDB1t, CFaceDB *pFaceDB2t);
		void				GetGeomParams(GEOMPARAMS *gp);
		int				Getxlen();
		int				Getylen();

	private:
		void	GetCornerFace(CORNER *c, int nFace, int num);
		void	GetCornerName(CORNER *c, int nFace, int num);

	// Generated message map functions
protected:
	//{{AFX_MSG(CWndFace)
	afx_msg void OnPaint();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	};

#endif /* CDRAWREC_H */
