#ifndef CREPORT_H
#define CREPORT_H
#include "CMemory.h"
class CReport : public CPanorama
	{
	public:
		CReport();
		~CReport();
		CReport(CView *pView, CBureaucrat *pBureau);
		
		void AppendMsg(char *str);
		void Draw(Rect *area);
		
		int Save(char *filename);
		
	private:
		void DrawLine(long Line);
		void DrawCharLine(long lPos);
		int GetCharHeight();
		int GetCharWidth();
		long GetLineNumber(long lPos);
		
		CMemory		*pMem;					/*CMemory object storing the characters*/
		char 		*pText;					/*pointer to the data of pMem when it's locked*/
		long		lReportLen;				/*Length of the report in characters*/
		long		lLine;					/*Number of lines*/
		CArray		*pLineArray;			/*The lth element contain the position of the first character of the lth line in pText*/
	};
#endif /* CREPORT_H */
