#ifndef ERROR_H
#define ERROR_H

/* File */
#define ERR_FILE_READ						-2
#define ERR_FILE_OPEN						-3

/* File Format */
#define ERR_FF									-20
#define ERR_FF_TRAINING_ENDTAG			-21
#define ERR_FF_RECONSTRUCTION_ENDTAG	-22
#define ERR_FF_RECOGNIZE_ENDTAG			-23
#define ERR_FF_MEET_ENDTAG					-24
#define ERR_FF_LOAD_EIGEN_ENDTAG			-25
#define ERR_FF_CATEGORIZE_ENDTAG			-26

/* Memory */
#define ERR_MEM_GETPTR						-50
#define ERR_MEM_ALLOCATE					-51
#define ERR_MEM_REALLOCATE					-52
#define ERR_MEMORY							-53

/* Matrix */
#define	ERR_MAT_LOAD_ROW					-100
#define	ERR_MAT_LOAD_COL					-101
#define	ERR_MAT_LOAD_HDR					-103

#endif /* ERROR_H */
